#!/usr/bin/env perl 

# psf_graph.pl         
#
#   v0.01  11-03-2004 : Initial implementation.
#				

use Getopt::Std;
use File::Spec::Functions;

getopts("dDhHE:P:W:v");

if ($opt_d) { $debug = 1; }
if ($opt_v) { $verbose = 1; }
if ($opt_h) { usage(); }
if ($opt_D) { $PerfstatGrapherDebug = 1; }
if ($opt_H) { $PerfstatGrapherHelp = 1; }

if ($opt_E) {
   $ExcelTemplateOpt = sprintf ("/E %s", $opt_E);
} 

if ($opt_W) {
   $WordTemplateOpt = sprintf ("/W %s", $opt_W);
} 

if ($opt_P) {
   $ProgramPath = $opt_P;
} else {
   $ProgramPath =  "\"C:\\Program Files\\na_psf\\VB\\PerfstatGrapher.exe\"";
}

$PSFDir = $ARGV[0];
# Get the full path  
$abs_path = File::Spec->rel2abs( $PSFDir ) ;

if ($PerfstatGrapherHelp) {   
   $cmd = "$ProgramPath /h";
} else {
   $cmd = "$ProgramPath $abs_path";
}
if ($PerfstatGrapherDebug) {
   $cmd = sprintf ("%s /D", $cmd);
}
if ($WordTemplateOpt) {
   $cmd = sprintf ("%s %s", $cmd, $WordTemplateOpt);
}
if ($ExcelTemplateOpt) {
   $cmd = sprintf ("%s %s", $cmd, $ExcelTemplateOpt);
}

if ($debug) {
	printf ("Command : %s \n", $cmd);
}
$starttime = time();
@results = `$cmd`;
$endtime = time();
if ($verbose) {
   printf ("Elapsed seconds: %d\n", ($endtime - $starttime));
}
foreach $result (@results) {
   print $result;
}

sub usage {
   print <<EOM;
psf_graph.pl [-h] [-P <path to PerfstatGrapher.exe>] 
                  [-E <path to Perfstat.xlt>] 
                  [-W <path to Word Doc template>]  <psf_files directory path >

Graphs perfstat data and a from perfstat filter output files. 

EOM
exit;

}

