#!/usr/bin/env perl 

# This script is provided "as is" it is
# not warranted but may be supported on a limited basis
# by Network Appliance.
#
# psf_compare_timestamps.pl
#
#   PerfStatFilter to compare two timestamps. Returns 1 if timestamp1 > timestamp 1,
#						      0 if timestamp1 = timestamp2, 
#						      -1 if timestamp1 < timestamp2

$timestamp1 = $ARGV[0];
$timestamp2 = $ARGV[1];
$result = compare_timestamps ($timestamp1, $timestamp2);
printf ("%d\n", $result);


sub compare_timestamps {
   my ($ts1, $ts2) = @_;

   my (@timestamp_parts, $date, @dateparts);
   my ($mo1, $day1, $year1);
   my ($mo2, $day2, $year2);
   my ($time, @timeparts);
   my ($hour1, $min1, $sec1);
   my ($hour2, $min2, $sec2);

   @timestamp_parts = split (/ /, $ts1);
   $date = $timestamp_parts[0];
   $time = $timestamp_parts[1];
   @dateparts = split (/\//, $date);
   @timeparts = split (/:/, $time);
   $mo1 = $dateparts[0];
   $day1 = $dateparts[1];
   $year1 = $dateparts[2];
   $hour1 = $timeparts[0];
   $min1  = $timeparts[1];
   $sec1  = $timeparts[2];

   @timestamp_parts = split (/ /, $ts2);
   $date = $timestamp_parts[0];
   $time = $timestamp_parts[1];
   @dateparts = split (/\//, $date);
   @timeparts = split (/:/, $time);
   $mo2 = $dateparts[0];
   $day2 = $dateparts[1];
   $year2 = $dateparts[2];
   $hour2 = $timeparts[0];
   $min2  = $timeparts[1];
   $sec2  = $timeparts[2];

   if ($year1 > $year2) {
        $result = 1;
   }
   elsif ($year1 < $year2) {
        $result = -1;
   }
   elsif ($mo1 > $mo2) {
        $result = 1;
   }
   elsif ($mo1 < $mo2) {
        $result = -1;
   }
   elsif ($day1 > $day2) {
        $result = 1;
   }
   elsif ($day1 < $day2) {
        $result = -1;
   }
   elsif ($hour1 > $hour2) {
        $result = 1;
   }
   elsif ($hour1 < $hour2) {
        $result = -1;
   }
   elsif ($min1 > $min2) {
        $result = 1;
   }
   elsif ($min1 < $min2) {
        $result = -1;
   }
   elsif ($sec1 > $sec2) {
        $result = 1;
   }
   elsif ($sec1 < $sec2) {
        $result = -1;
   }
   else {
        $result = 0;
   }

   return ($result);
}

