#!/usr/bin/env perl 

use Getopt::Std;
getopts("df:h");

if ($opt_h) { usage(); }

if ($opt_f) {
   $filer = $opt_f;   
} 

if ($opt_d) {
   $debug = 1;        
} else {
   $debug = 0;
}

$found_in_cmd=0;
$perfstat_file = $ARGV[0];
open(INPUTA, '<' . $perfstat_file) || die 'Unable to open perfstat file (arg1) .';

while ($Line = <INPUTA>) { 
   if ($Line =~ /^-f / ) {
      chomp $Line;
      @line = split (/\s+/, $Line);
      foreach $tmp_line ( @line ) {
         if ($tmp_line =~ /^-f/ ) {
            next;
         }
         chomp $tmp_line;
         printf ("%s\n", $tmp_line);
         $found_in_cmd=1;
      }
   }
   elsif ($Line =~ /^FILER_TARGETS/) {
      chomp $Line;
      @line = split (/\s+/, $Line);
      $filers_str = $line[2];
      @filers = split (/[,"]/, $filers_str);
      foreach $filer ( @filers ) {
         $len = length $filer;
         if (substr($filer,1,1) =~ /\"/) {
            $filer = substr ($filer, 2, $len-1);
            $len--;
         }
         if (substr($filer,$len,1) =~ /"/) {
            $filer = substr ($filer, 1, $len-1);
         }
         if ($filer) {
            printf ("%s\n", $filer);
         }
         $found_in_cmd=1;
      }
      last;
   }
   elsif (($Line =~ /^COMMAND_LINE/) &&
          ($Line =~ /-f /)) {
      chomp $Line;
      @line = split (/\s+/, $Line);
      $filers_str = $line[2];
      @filers = split (/,/, $filers_str);
      foreach $filer ( @filers ) {
         if ($filer =~ /"/ ) {
            chop $filer;
         }
         printf ("%s\n", $filer);
         $found_in_cmd=1;
      }
   }
   elsif ($Line =~ /=-=-=-=/) {
      last;
   }
}
if (!$found_in_cmd) {
   # Assume only one and get it from sysconfig
   while ($Line = <INPUTA>) {
      if   ($Line =~ / sysconfig -av/) {
         while ($Line = <INPUTA>) {
            if   ($Line =~ /System Serial Number/) {
               @line = split (/\s+/, $Line);
               $filer_str = $line[5];
               chomp $filer_str;
               # take off parens
               $filer = substr($filer_str, 1, length($filer_str)-2);
               if ($filer) {
                  printf ("%s\n", $filer);
               }
            }
         }
      }
   } 
}
