#!/usr/bin/env perl 

# This script is provided "as is" it is
# not warranted but may be supported on a limited basis
# by Network Appliance.
#
# psf_parity_disks.pl
#
#   PerfStatFilter to get a list of parity disks. 
#
#   v0.01  03-03-2006 : Initial implementation.
#


use Getopt::Std;
getopts("df:h");

if ($opt_h) { usage(); }

if ($opt_d) {
   $debug = 1;  
} else {
   $debug = 0;
}

if ($opt_f) {
   $filer = $opt_f;
}

$perfstat_file = $ARGV[0];
open(INPUTA, '<' . $perfstat_file) || die 'Unable to open perfstat file (arg1) .';

@line;

while ($Line = <INPUTA>) { 
   if ( ( $Line =~ /^=-=-/ ) &&
           ( $Line =~ /PRESTATS/ ) &&
           ( $Line =~ /sysconfig -r/ ) ) {
      @line = split (/\s+/, $Line);
      $curr_filer = $line[2];
      if ( $debug ) {
         printf ("Current filer : %s \n", $curr_filer);
      }
      if ( (!$filer) ||
            ($filer =~ /^$curr_filer/) )  {
         last;
      }
   }
   next;
}

while ($Line = <INPUTA>) { 
   if ( $Line =~ /=-=-=-/ ) {
      last;
   }
   elsif ( $Line =~ /parity/ ) {
      @line = split (/\s+/, $Line);
      $disk_name = $line[2];
      printf ("%s\n", $disk_name);
   }
}

sub usage {
   print <<EOM;
psf_parity_disks.pl [-DhH] [-f <filer>] <perfstat filename>

Lists parity disks from sysconfig -r          

    Arguments and switches - 
       -D          Display Data as well as headers
       -f <filer>  For multi-filer perfstat choose this filer.
       -h          This message.
       -H          Display header.
EOM
exit;

}
