#!/usr/bin/env perl 

# This script is provided "as is" it is
# not warranted but may be supported on a limited basis
# by Network Appliance.
#
# psf_split_sysstat.pl
#
#   PerfStatFilter for splitting sysstat file if over 32K lines to
#	accomodate Excel limitations.  
#
#   v0.01  02-04-2005 : Initial implementation.
#


use Getopt::Std;
getopts("dh");

if ($opt_h) { usage(); }

if ($opt_d) {
   $debug = 1; 
} else {
   $debug = 0;
}

$sysstat_file = $ARGV[0];
$output_base = $ARGV[1];
$curr_file_num = 0;
$outfile = sprintf ("%s.%d.txt",$output_base, $curr_file_num);

open(INPUTA, '<' . $sysstat_file) || die 'Unable to open sysstat file (arg1) .';
open(OUTPUTA, '>'. $outfile) || die 'Cant open output ';

# Save the header lines

for ($i = 0; $i < 2; $i++) {
    $Line = <INPUTA>; 
    if (($Line =~ /Timestamp/) || 
        ($Line =~ /^\s+/)) { 
      push (@header, $Line);
    }
    else {
      printf ("sysstat Header line not found \n");
      exit ();
    }
}
close (INPUTA);

# Sort the original sysstat file.
$sorted_sysstat_file = sprintf ("%s.sorted.txt",$output_base);
system ("sort $sysstat_file > $sorted_sysstat_file ");

$lines_in_curr_file = 0;
open(INPUTA, '<' . $sorted_sysstat_file) || die 'Unable to open sorted sysstat file (arg1) .';
foreach $hdr_line (@header) {
	printf (OUTPUTA "%s", $hdr_line);
	$lines_in_curr_file++;
}

while ($Line = <INPUTA>) {
    if (($Line =~ /Timestamp/) ||
        ($Line =~ /^\s+/)) {
	next;
    }
    if ($lines_in_curr_file > 32766) {
      close (OUTPUTA);
      $lines_in_curr_file = 0;
      $curr_file_num++;
      $outfile = sprintf ("%s.%d.txt",$output_base, $curr_file_num);
      open(OUTPUTA, '>'. $outfile) || die 'Cant open output ';
      foreach $hdr_line (@header) {
         printf (OUTPUTA "%s", $hdr_line);
	 $lines_in_curr_file++;
      }
    }
    printf (OUTPUTA "%s",$Line);
    $lines_in_curr_file++;
}   
close (OUTPUTA);
