#!/usr/bin/env perl 

# This script is provided "as is" it is
# not warranted but may be supported on a limited basis
# by Network Appliance.
#
# psf_transpose.pl
#
#   PerfStatFilter to transpose output with instance per column
#   v.02   02-07-2005 : Changed to support vol_by_rg files by 
#                       testing if $line[2] =~ /plex/ and if so 
#			constructing th instance name as concatenatio
#			of vol_name/rg_name. 
#   v.01   10-25-2004 : Created.
#

use Getopt::Std;
getopts("C:dh");

if ($opt_C) {
   $column = $opt_C;
} else {
   usage();
   exit; 
}

if ($opt_h) { usage(); }

if ($opt_d) {
   $debug = 1;  
} else {
   $debug = 0;
}

$input_file = $ARGV[0];

open(INPUTA, '<' . $input_file) || die 'Unable to open input file (arg1) .';

$sample = 0;
$next_instance = 1;
printf ("Timestamp, ");
while ($Line = <INPUTA>) {
	if ($Line =~ /^Timestamp/) {
		next;
	}
	$Line =~ s/\r//g;     # Remove DOS carraige returns
        chomp $Line;
        @line = split (/,/, $Line);
        $new_timestamp = $line[0];
        $instance = $line[1]; 
	if ($line[2] =~ /plex/) {
		# Trim leading blank 
		if (substr ($line[2], 0, 1) eq " ") {
			$line[2] = substr ($line[2], 1, length($line[2])-1);
		}
		$instance = join "/", $line[1], $line[2]
	}
        $value = $line[$column];
        if ($new_timestamp ne $timestamp) {
		$sample++;
		$timestamp_list[$sample] = $new_timestamp;
		$timestamp = $new_timestamp;
	}
	$instance_num = $instance_idx{$instance};
	if (!$instance_num) {
		$instance_num = $next_instance;
		$instance_idx{$instance} = $instance_num;
		printf ("%s, ", $instance);
		$next_instance++;
	}
	$value_array[$sample][$instance_num] = $value;
}
printf ("\n");
for ($i=1; $i <= $sample; $i++) {
	printf ("%s, ", $timestamp_list[$i]);
	for ($j=1; $j< $next_instance; $j++) {
		printf ("%s, ", $value_array[$i][$j]);
	}
	printf ("\n");
}

sub usage {
   print <<EOM;
psf_transpose.pl [-h] -C <col> <filename>

EOM
exit;

}
