#!/usr/bin/env perl

# This script is provided "as is" it is
# not warranted but may be supported on a limited basis
# by Network Appliance.
#
# psf_unix_timestamp.pl
#
#   input is a perfstat file 
#   output is a string in timestamp format from first timestamp
#
#   PerfStatFilter for Windows perfstat timestamps.          
#
#   v0.01  03-17-2004 : initial implementation

use Getopt::Std;
getopts("hdf:");

if ($opt_h) { usage(); }

if ($opt_d) {
   $debug = 1;  
} else {
   $debug = 0;
}

if ($opt_f) {
   $filer = $opt_f;
}

$perfstat_file = $ARGV[0];
open(INPUTA, '<' . $perfstat_file) || die 'Unable to open perfstat file (arg1) .';

while ($Line = <INPUTA>) {
   if ( ( $Line =~ /^=-=-/ ) &&
        ( $Line =~ /PRESTATS/ ) &&
        ( $Line =~ /=-= date/ ) ) {
      @line = split (/\s+/, $Line);
      $curr_filer = $line[2];
      if ( $debug ) {
         printf ("Current statit filer : %s \n", $curr_filer);
      }
      if ( (!$filer) ||
           ($filer =~ /^$curr_filer/) )  {
         $Line = <INPUTA>;                    # This line has the date
         @line = split (/ +/, $Line);
         $mo = $line[1];
         $day = $line[2];
         $time = $line[3];
         $yr = $line[5];

         $mo_num = month_to_numeric ($mo);
         $timestamp = sprintf ("%02d\/%02d\/%d %s",
                           $mo_num, $day,
                           $yr, $time);

         printf ("%s \n", $timestamp );
         last;
      }
   }
}

sub month_to_numeric {
   local ($month) = @_ ;
   my $result;

   if ($month =~ /Jan/ ) {
        $result = 1;
   }
   elsif ($month =~ /Feb/ ) {
        $result = 2;
   }
   elsif ($month =~ /Mar/ ) {
        $result = 3;
   }
   elsif ($month =~ /Apr/ ) {
        $result = 4;
   }
   elsif ($month =~ /May/ ) {
        $result = 5;
   }
   elsif ($month =~ /Jun/ ) {
        $result = 6;
   }
   elsif ($month =~ /Jul/ ) {
        $result = 7;
   }
   elsif ($month =~ /Aug/ ) {
        $result = 8;
   }
   elsif ($month =~ /Sep/ ) {
        $result = 9;
   }
   elsif ($month =~ /Oct/ ) {
        $result = 10;
   }
   elsif ($month =~ /Nov/ ) {
        $result = 11;
   }
   elsif ($month =~ /Dec/ ) {
        $result = 12;
   }
   else {
        $result = -1;
   }
   return $result;
}

