#!/usr/bin/env perl 

# This script is provided "as is" it is
# not warranted but may be supported on a limited basis
# by Network Appliance.
#
# psf_vol_info.pl
#
#   PerfStatFilter for Filer Vol information .
#
#   NOTE 12/06/2006 - This is woefully obsolete. Need to
# get into the FlexVol age. 
#   v0.01  06-23-2004 : Initial implementation.
#

# EXPORTED CONSTANTS (Not really, you have to copy them)

use constant    _NA_VOL_NAME            => 0;
use constant    _NA_VOL_RAID_TYPE       => 1;
use constant    _NA_VOL_RAID_SIZE       => 2;
use constant    _NA_VOL_MIRRORED        => 3;

use Getopt::Std;
getopts("AdDf:hH");

if ($opt_h) { usage(); }

if ($opt_d) {
   $debug = 1;  
} else {
   $debug = 0;
}

if ($opt_D) {
   $data_plus_header = 1;  
} else {
   $data_plus_header = 0;  
}

if ($opt_f) {
   $filer = $opt_f;
}

if ($opt_A) {
   $type = "aggr";
} else {
   $type = "vol";
}

if ($opt_H) {
   $header = 1;  
} else {
   $header = 0;
}

# from psf_versions.pl 

use constant    _NA_VERS_PERFSTAT_MAJOR => 0;
use constant    _NA_VERS_PERFSTAT_MINOR => 1;
use constant    _NA_VERS_ONTAP_VERSION  => 2;
use constant    _NA_VERS_ONTAP_MAJOR    => 3;
use constant    _NA_VERS_ONTAP_MINOR    => 4;
use constant    _NA_VERS_FILER_MODEL    => 5;
use constant    _NA_VERS_FILER_MAGIC1   => 6;
use constant    _NA_VERS_FILER_MAGIC2   => 7;

 
$perfstat_file = $ARGV[0];
open(INPUTA, '<' . $perfstat_file) || die 'Unable to open perfstat file (arg1) .';

@line;

$header_line = "Vol Name, RAID Type, RAID Size, Mirrored, \n";
$version_line = `psf_versions.pl $perfstat_file`;
@versions = split (/,/, $version_line);
$perfstat_major = $versions[_NA_VERS_PERFSTAT_MAJOR];
$perfstat_minor = $versions[_NA_VERS_PERFSTAT_MINOR];
$ontap_major = $versions[_NA_VERS_ONTAP_MAJOR];
$ontap_minor = $versions[_NA_VERS_ONTAP_MINOR];
$model = $versions[_NA_VERS_FILER_MODEL];

if ( $debug ) { print @versions; }

if ( !$nice_output && $header ) {
   print $header_line;
   if (!$data_plus_header) {
     exit;
   }
}
 
while ($Line = <INPUTA>) { 
   if ( ( $Line =~ /^=-=-/ ) &&
           ( $Line =~ /PRESTATS/ ) &&
           ( $Line =~ /$type status -v/ ) ) {
      @line = split (/\s+/, $Line);
      $curr_filer = $line[2];
      if ( $debug ) {
         printf ("Current statit filer : %s \n", $curr_filer);
      }
      if ( (!$filer) ||
            ($filer =~ /^$curr_filer/) )  {
         last;
      }
   }
   next;
}

while ($Line = <INPUTA>) { 
   if ( $Line =~ /=-=-=-/ ) {
      last;
   }
   elsif ( $Line =~ /nosnap/ ) {
      $Line =~ s/^\s+//;         # Remove leading white space
      @line = split (/\s+/, $Line);
      $vol_name = $line[0];
      $raid_type = $line[2];
      $Line = <INPUTA>;  
      if (( $Line =~ /mirrored/ ) || ( $Line =~ /resyncing/ ) ){
         $mirrored = 1;
      }
      else {
         $mirrored = 0;
      }
   }
   elsif ( $Line =~ /raidsize/ ) {
      @line = split (/,/, $Line);
      if ($type eq "aggr") { 
      	$raidsize_str = $line[0]; 
      } else {
      	$raidsize_str = $line[1]; 
      }
      if ($debug) {
        printf ("raidsize str : %s \n", $raidsize_str);
      }
      @raidsize_parts = split (/=/, $raidsize_str);
      $raidsize = $raidsize_parts[1];
      printf ("%s, %s, %d, %d, \n",
               $vol_name,
               $raid_type,
               $raidsize,
               $mirrored);
   }
   elsif (( $Line =~ /Containing aggregate/ ) && 
	  ( $type eq "vol" ) ) {
	printf ("%s, %s, %d, %d, \n",
               $vol_name,
               $raid_type,
               $raidsize,
               $mirrored);
   }
}

sub usage {
   print <<EOM;
psf_vol_info.pl [-ADhH] [-f <filer>] <perfstat filename>

Summarizes vol info         

    Arguments and switches - 
       -A          Look for aggregates rather than vols. 
       -D          Display Data as well as headers
       -f <filer>  For multi-filer perfstat choose this filer.
       -h          This message.
       -H          Display header.
EOM
exit;

}
