#!/usr/bin/env perl

# This script is provided "as is" it is
# not warranted but may be supported on a limited basis
# by Network Appliance.
#
# psf_win_timestamp.pl
#
#   input is a perfstat file 
#   output is a string in timestamp format from first timestamp
#
#   PerfStatFilter for Windows perfstat timestamps.          
#
#   v0.01  03-17-2004 : initial implementation

use Getopt::Std;
getopts("hd");

if ($opt_h) { usage(); }

if ($opt_d) {
   $debug = 1;  
} else {
   $debug = 0;
}

$perfstat_file = $ARGV[0];
open(INPUTA, '<' . $perfstat_file) || die 'Unable to open perfstat file (arg1) .';

           $Line = <INPUTA>;                    # This line has perfstat version
           $Line = <INPUTA>;                    # This line has the date
           @line = split (/ +/, $Line);
           $date = $line[1];
           $Line = <INPUTA>;                    # This line has the time
           @line = split (/ +/, $Line);
           if ( length($line[0]) ) {
              $time = $line[0];
              $ampm = $line[1];
           }
           else {
              $time = $line[1];
              $ampm = $line[2];
           }
           if ( length($ampm) == 0 ) {
              chop $time;
              chop $time;
              $ampm = chop $time;
              if ( $ampm =~ /p/ ) {
                 $ampm = "PM";
              }
              else {
                 $ampm = "AM";
              }
           }
           if ($debug) { printf ("AM/PM     : %s \n", $ampm); }
           @timeparts = split (/:/, $time);
           $hour = @timeparts[0];
           $min  = @timeparts[1];
           if ( ( $ampm =~ /PM/ ) &&
                ( $hour < 12 ) )  {
              # Add 12 hours to time
              $hour += 12;
           }
           elsif ( ( $ampm =~ /AM/ ) &&
                   ( $hour == 12 ) ) {
              $hour = 0;
           }
           $time = sprintf ("%02d:%02d:%02d", $hour, $min, 0);

           if ($debug) { printf ("Base Time : %s \n", $time); }
           $base_timestamp = sprintf ("%s %s", $date, $time);
           if ($debug) { printf ("Base timestamp : %s \n", $base_timestamp ); }

           printf ("%s \n", $base_timestamp );

